;;; $Id: aop-3-7.tst,v 1.3 2006/01/04 07:00:55 leavens Exp $

(require (lib "aop-3-7.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (run "run let x = 3 in x") ==> 3 )
    ( (run "around get x do 0
            run let x = 3 in x") ==> 0 )
    ( (run "around get y do add1(proceed)
            run let y = 10 in +(y, y)") ==> 22 )
    ( (run "around get z do add1(proceed)
            run let y = 10 in +(y, y)") ==> 20 )
    ( (run "around get y do begin set y = add1(proceed); proceed end
            run let y = 10 in +(y, y)") ==> 23 )
    ( (run "around get z do add1(proceed)
            around get y do begin set y = add1(proceed); proceed end
            run let y = 10 in +(y, y)") ==> 23 )
    ( (run "around get * do add1(proceed)
            run let y = 10
                z = 5
            in +(y, z)") ==> 17 )
    ( (run "around get * do add1(proceed)
            around get * do sub1(proceed)
            run let y = 10
                    z = 5
                in +(y, z)") ==> 15 )
    ( (run "around get * do 0
            around get y do begin set y = add1(proceed); proceed end
            run let y = 10
                    z = 5
                in +(y, z)") ==> 0 )
    ( (run "around get * do add1(proceed)
            around get y do begin set y = add1(proceed); proceed end
            run let y = 10
                    z = 5
                in +(y, z)") ==> 18 )
    ( (run "around get y do *(proceed, proceed)
            around get y do begin set y = add1(proceed); proceed end
            run
            let y = 10
                z = 0
            in +(y, z)") ==> 132 )
    ( (run "around get y do begin set y = add1(proceed); proceed end
            around get y do *(proceed, proceed)
            run
            let y = 10
                z = 0
            in +(y, z)") ==> 10201 )
    ( (run "around set x do 0
            run let x = 3 in set x = 4") ==> 0 )
    ( (run "around set x do 0
            run let x = 3 in begin set x = 4; x end") ==> 3 )
    ( (run "around set x do proceed
            run let x = 3 in begin set x = 4; x end") ==> 4 )
    ( (run "around set * do LHS = 0
            run let x = 3 in begin set x = 4; x end") ==> 0 )
    ( (run "around set * do LHS = 0
            run
            let x = 342
                y = 99
            in begin set x = 4; set y = 7; +(x,y) end") ==> 0 )
    ( (run "around set * do LHS = 0
            around get * do add1(proceed)
            run
            let x = 342
                y = 99
            in begin set x = 4; set y = 7; +(x,y) end") ==> 2 )
    ( (run "around set y do begin set last = RHS; proceed end
            run
            let last = 0
                y = 3
            in begin
                set y = +(y,1);
                set y = add1(y);
                +(*(10000,last),y)
             end") ==> 50005 )
    ( (run "around set y do begin set accum = +(accum,RHS); proceed end
            run
            let accum = 0
                y = 3
            in begin
                set y = +(y,1);
                set y = add1(y);
                +(*(10000,accum),y)
             end") ==> 90005 )

    )
 )
