;;; $Id: ch3-9-modified-in-class.tst,v 1.2 2006/11/30 22:51:04 leavens Exp $
;;; Test cases for the 3-6-2 interpreter modified in class

(require (lib "ch3-9-modified-in-class.scm" "lib342")
         (lib "relax-type-checking.scm" "typedscm"))

(deftype run-tests (-> ((list-of datum)) void))
(define run-tests
  (lambda (tests)
    (for-each (lambda (test)
                (displayln (cadr (test-type (list-of datum?) test)))
                (ignore (eval test)))
              tests)))

(run-tests
 (test-type
   (list-of datum?)
   `(
     (run "var y,z, res;
          { x = 3;
            y = 4;
            res = +(*(100,x), y);
            z = equal?(304, res);
            print(z)
          }")
     (run "var x, y;
          { y  = 10;
            x = 3;
            do {
               x = -(x,1);
               y = *(y,y)
            } until (equal?(x,0));
            print(y)
          }")
     (run "var x, y, res;
          { y  = 10;
            res = after
                    x = 0;
                    do {
                       x = -(x,1);
                       y = *(y,y)
                    } until (less?(x,0))
                  value *(y,x);
            x = sub1(0);
            print(x); print(y)
          }")
    
     ))
 )
