;; $Id: lambda-1-exp-examples.tst,v 1.3 2006/01/05 22:24:09 leavens Exp $

(require (lib "lambda-1-exp-examples.scm" "lib342")
         (lib "lambda-1-exp.scm" "lib342"))

(define lexp1 (parse-expression '(lambda (x) (f x))))
(define lexp2 (lambda-exp 'z (app-exp lexp1
                                      (parse-expression '(g (h y))))))
(define lexp3 (lambda-exp 'f lexp2))
(define lexp4 (app-exp lexp3 (parse-expression
                              '(car (cdr (x (y z)))))))
(define lexp5 (lambda-exp 'y lexp4))
(define lexp6 (lambda-exp 'f lexp4))
(define lexp7 (app-exp lexp5 lexp2))

(run-regression-tests-equal?
 `(
    ( (count-var-exps (var-exp 'x)) ==> 1 )
    ( (count-var-exps (app-exp (var-exp 'x) (var-exp 'y))) ==> 2 )
    ( (count-var-exps (parse-expression '(x y))) ==> 2 )
    ( (count-var-exps (parse-expression '(lambda (x) x))) ==> 1 )
    ( (count-var-exps (parse-expression '(f (lambda (x) x)))) ==> 2 )

    ( (all-var-exps (parse-expression 'x)) ==> (x) )
    ( (all-var-exps (parse-expression '(x y))) ==> (x y) )
    ( (all-var-exps (parse-expression '(lambda (x) y))) ==> (y) )
    ( (all-var-exps (parse-expression '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

   ( (free-vars (parse-expression 'x)) ==> (x) )
   ( (free-vars (parse-expression '(x y))) ==> (x y) )
   ( (free-vars (parse-expression ',lexp1)) ==> (f) )
   ( (free-vars (parse-expression ',lexp2))
     ==> (f g h y) )
   ( (free-vars (parse-expression ',lexp3))
     ==> (g h y) )
   ( (free-vars (parse-expression ',lexp4))
     ==> (g h y car cdr x y z) )
   ( (free-vars (parse-expression ',lexp5))
     ==> (g h car cdr x z) )
   ( (free-vars (parse-expression ',lexp6))
     ==> (g h y car cdr x y z) )
   ( (free-vars (parse-expression ',lexp7))
     ==> (g h car cdr x z f g h y) )
   ( (free-vars (parse-expression '((lambda (y) y) (lambda (x) (y x)))))
     ==> (y) )

   ( (free? 'x (parse-expression 'x))      ==> #t )
   ( (free? 'x (parse-expression 'y))      ==> #f )
   ( (free? 'x (parse-expression '(x y)))  ==> #t )
   ( (free? 'g (parse-expression ',lexp1)) ==> #f )
   ( (free? 'f (parse-expression ',lexp2)) ==> #t )
   ( (free? 'f (parse-expression ',lexp3)) ==> #f )
   ( (free? 'x (parse-expression ',lexp4)) ==> #t )
   ( (free? 'z (parse-expression ',lexp5)) ==> #t )
   ( (free? 'y (parse-expression ',lexp6)) ==> #t )
   ( (free? 'y (parse-expression ',lexp7)) ==> #t )
   
   ( (bound-vars (parse-expression 'x)) ==> () )
   ( (bound-vars (parse-expression '(x y))) ==> () )
   ( (bound-vars (parse-expression '(lambda (x) (lambda (x) y))))
     ==> () )
   ( (bound-vars (parse-expression ',lexp1)) ==> (x) )
   ( (bound-vars (parse-expression ',lexp2)) ==> (x) )
   ( (bound-vars (parse-expression ',lexp3)) ==> (f x) )
   ( (bound-vars (parse-expression ',lexp4)) ==> (f x) )
   ( (bound-vars (parse-expression ',lexp5)) ==> (y f x) )
   ( (bound-vars (parse-expression ',lexp6)) ==> (f x) )
   ( (bound-vars (parse-expression ',lexp7)) ==> (y f x x) )

   ( (bound? 'x (parse-expression 'x))      ==> #f )
   ( (bound? 'x (parse-expression '(x y)))  ==> #f )
   ( (bound? 'g (parse-expression ',lexp1)) ==> #f )
   ( (bound? 'f (parse-expression ',lexp2)) ==> #f )
   ( (bound? 'f (parse-expression ',lexp3)) ==> #t )
   ( (bound? 'x (parse-expression ',lexp4)) ==> #t )
   ( (bound? 'z (parse-expression ',lexp5)) ==> #f )
   ( (bound? 'y (parse-expression ',lexp6)) ==> #f )
   ( (bound? 'y (parse-expression ',lexp7)) ==> #t )
    )
 )

