;; $Id: lambda-1-quote-exp-examples.tst,v 1.3 2006/01/05 22:24:09 leavens Exp $

(require (lib "lambda-1-quote-exp-examples.scm" "lib342")
         (lib "lambda-1-quote-exp.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (quote-exp->symbol (quote-exp 'z)) ==> z )

    ( (count-var-exps (var-exp 'x)) ==> 1 )
    ( (count-var-exps (quote-exp 'z)) ==> 0 )
    ( (count-var-exps (app-exp (var-exp 'x) (var-exp 'y))) ==> 2 )
    ( (count-var-exps (parse-expression '(x y))) ==> 2 )
    ( (count-var-exps (parse-expression '(lambda (x) x))) ==> 1 )
    ( (count-var-exps (parse-expression '((lambda (x) x) (quote z))))
      ==> 1 )
    ( (count-var-exps (parse-expression '((lambda (x) x) 'z))) ==> 1 )
    ( (count-var-exps (parse-expression '(f (lambda (x) x)))) ==> 2 )

    ( (all-var-exps (parse-expression 'x)) ==> (x) )
    ( (all-var-exps (parse-expression '(quote z))) ==> () )
    ( (all-var-exps (parse-expression '(x y))) ==> (x y) )
    ( (all-var-exps (parse-expression '(lambda (x) y))) ==> (y) )
    ( (all-var-exps (parse-expression '((lambda (x) x) (quote z))))
      ==> (x) )
    ( (all-var-exps (parse-expression '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-var-exps 'new 'old (parse-expression 'old))
      ==> new )
    ( (subst-var-exps 'n 'o (parse-expression '(quote z)))
      ==> (quote z) )
    ( (subst-var-exps 'y 'x (parse-expression '(x y)))
      ==> (y y) )
    ( (subst-var-exps 'y 'x (parse-expression '(lambda (x) y)))
      ==> (lambda (x) y) )
    ( (subst-var-exps 'y 'x (parse-expression '((lambda (x) x) (quote z))))
      ==> ((lambda (x) y) (quote z)) )
    ( (subst-var-exps 'y 'x (parse-expression '(f (lambda (x) (x (f x))))))
      ==> (f (lambda (x) (y (f y)))) )
    )
 )

