;;; $Id: lambda-1-quote-exp.tst,v 1.3 2006/01/05 22:24:09 leavens Exp $

(require (lib "lambda-1-quote-exp.scm" "lib342")
         (lib "lambda-1-quote-exp-tests.scm" "lib342"))

(run-tests)

(run-regression-tests-equal?
 `(
   ( (var-exp? (var-exp 'x))
     ==> #t )
   ( (quote-exp? (var-exp 'x))
     ==> #f )
   ( (lambda-exp? (var-exp 'x))
     ==> #f )
   ( (app-exp? (var-exp 'x))
     ==> #f )

   ( (var-exp? (quote-exp 'x))
     ==> #f )
   ( (quote-exp? (quote-exp 'x))
     ==> #t )
   ( (lambda-exp? (quote-exp 'x))
     ==> #f )
   ( (app-exp? (quote-exp 'x))
     ==> #f )

   ( (var-exp? (lambda-exp 'x (var-exp 'x)))
     ==> #f )
   ( (quote-exp? (lambda-exp 'x (var-exp 'x)))
     ==> #f )
   ( (lambda-exp? (lambda-exp 'x (var-exp 'x)))
     ==> #t )
   ( (app-exp? (lambda-exp 'x (var-exp 'x)))
     ==> #f )

   ( (var-exp? (app-exp (var-exp 'x) (var-exp 'z)))
     ==> #f )
   ( (quote-exp? (app-exp (var-exp 'x) (var-exp 'z)))
     ==> #f )
   ( (lambda-exp? (app-exp (var-exp 'x) (var-exp 'z)))
     ==> #f )
   ( (app-exp? (app-exp (var-exp 'x) (var-exp 'z)))
     ==> #t )

   ( (var-exp->id (var-exp 'x)) ==> x )

   ( (quote-exp->symbol (quote-exp 'x)) ==> x )

   ( (lambda-exp->id (lambda-exp 'x (var-exp 'y)))  ==> x )

   ( (lambda-exp->body (lambda-exp 'x (var-exp 'y)))
     = (var-exp 'y) )

   ( (app-exp->rator (app-exp (var-exp 'x) (var-exp 'y)))
     = (var-exp 'x) )

   ( (app-exp->rand (app-exp (var-exp 'x) (var-exp 'y)))
     = (var-exp 'y) )
   )
 )
