;;; $Id: reference-3-7.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $

;;;;;;;;;;;;;;;; references ;;;;;;;;;;;;;;;;

(module reference-3-7 (lib "typedscm.ss" "typedscm")

(provide ref-of a-ref deref setref!)

(deftype a-ref (forall (T) (-> (number (vector-of T)) (ref-of T))))
(deftype deref (forall (T) (-> ((ref-of T)) T)))
(deftype setref! (forall (T) (-> ((ref-of T) T) void)))

(define-datatype reference reference?
  (a-ref
    (position integer?)
    (vec vector?)))

(deftype ref-of (forall (T)
                  (-> ((type-predicate-for T))
                      (type-predicate-for (ref-of T)))))
(define ref-of
  (forall (T?)
    (has-type-trusted (type-predicate-for (ref-of T?))
                      reference?)))

(deftype primitive-deref (forall (T) (-> ((ref-of T)) T)))
(define primitive-deref
  (has-type-trusted
    (forall (T) (-> ((ref-of T)) T))
    (lambda (ref)
      (cases reference ref
        (a-ref (pos vec) (vector-ref vec pos))))))

(deftype primitive-setref! (forall (T) (-> ((ref-of T) T) void)))
(define primitive-setref!
  (has-type-trusted
    (forall (T) (-> ((ref-of T) T) void))
    (lambda (ref val)
      (cases reference ref
        (a-ref (pos vec) (vector-set! vec pos val))))))

(define deref 
  (lambda (ref)
    (primitive-deref ref)))

(define setref! 
  (lambda (ref val)
    (primitive-setref! ref val)))

) ;; end module
