;;; $Id: remove-named-mod.tst,v 1.2 2006/01/05 22:24:09 leavens Exp $
;;; AUTHOR: Gary T. Leavens

(require (lib "remove-named-mod.scm" "lib342")
         (lib "sxml-helpers.scm" "lib342"))

(define sampledoc0
  '(*TOP*
       (urn:loc.gov:books:book
         (urn:loc.gov:books:title
             "Cheaper by the Dozen")
         (urn:ISBN:0-395-36341-6:number "1568491379")
         (urn:loc.gov:books:notes
           (urn:w3-org-ns:HTML:p
              "This is a "
               (urn:w3-org-ns:HTML:i "funny")
              " book!")))))

(define sampledoc1
  '(*TOP*
       (RESERVATION
         (NAME (@ (HTML:CLASS "largeSansSerif"))
           "Layman, A")
         (SEAT (@ (HTML:CLASS "largeMonotype")
                  (CLASS "Y"))
            "33B")
         (HTML:A (@ (HREF "/cgi-bin/ResStatus"))
            "Check Status")
         (DEPARTURE "1997-05-24T07:55:00+1"))))

(run-regression-tests-equal?
 `(

   ( (remove-named (document '() '() (named 'html '())) 'xyzzy)
     = (document '() '() (named 'html '())) )
   ( (remove-named sampledoc0 'urn:w3-org-ns:HTML:p)
     ==>
     (*TOP*
       (urn:loc.gov:books:book
         (urn:loc.gov:books:title
             "Cheaper by the Dozen")
         (urn:ISBN:0-395-36341-6:number "1568491379")
         (urn:loc.gov:books:notes))) )

   ( (remove-named sampledoc0 'urn:loc.gov:books:notes)
     ==>
     (*TOP*
       (urn:loc.gov:books:book
         (urn:loc.gov:books:title
             "Cheaper by the Dozen")
         (urn:ISBN:0-395-36341-6:number "1568491379"))) )

   ( (remove-named sampledoc0 'urn:w3-org-ns:HTML:i)
     ==>
     (*TOP*
      (urn:loc.gov:books:book
         (urn:loc.gov:books:title
             "Cheaper by the Dozen")
         (urn:ISBN:0-395-36341-6:number "1568491379")
         (urn:loc.gov:books:notes
           (urn:w3-org-ns:HTML:p
              "This is a "
              " book!")))) )

   ( (remove-named sampledoc1 'SEAT)
     ==>
     (*TOP*
       (RESERVATION
         (NAME (@ (HTML:CLASS "largeSansSerif"))
           "Layman, A")
         (HTML:A (@ (HREF "/cgi-bin/ResStatus"))
            "Check Status")
         (DEPARTURE "1997-05-24T07:55:00+1"))) )
   )
 )
