;; $Id: sym-cell-mod.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

;;; Adapted from Figure 4.5.1 : page 125, of EOPL first edition

(module sym-cell-mod (lib "typedscm.ss" "typedscm")

  (provide sym-cell? sym-cell sym-cell-ref sym-cell-set! sym-cell-swap!)

  ;; type predicates
  (deftype sym-cell? (type-predicate-for sym-cell))
  ;; constructor
  (deftype sym-cell (-> (symbol) sym-cell))
  ;; observer
  (deftype sym-cell-ref (-> (sym-cell) symbol))
  ;; mutators
  (deftype sym-cell-set! (-> (sym-cell symbol) void))
  (deftype sym-cell-swap! (-> (sym-cell sym-cell) void))

  (defrep (sym-cell (vector-of symbol)))

  (define sym-cell-tag 'sym-cell-tag)

  (define sym-cell
    (lambda (x)
      ;; ENSURES: result is a new sym-cell containing x
      (vector sym-cell-tag x)))

  (define sym-cell?
    (lambda (x)
      (has-type-trusted
        boolean
        (and (vector? x)
             (= (vector-length x) 2)
             (equal? (vector-ref x 0) sym-cell-tag)))))

  (define sym-cell-ref
    (lambda (x)
      ;; ENSURES: result is the contents of x
      (if (sym-cell? x)
          (vector-ref x 1)
          (error "Invalid argument to sym-cell-ref: " x))))

  (define sym-cell-set!
    (lambda (x value)
      (if (sym-cell? x) 
          (vector-set! x 1 value)
          (error "Illegal argument to sym-cell-set!: " x))))

  (define sym-cell-swap!
    (lambda (sc1 sc2)
      (let ((temp (sym-cell-ref sc1)))
        (sym-cell-set! sc1 (sym-cell-ref sc2))
        (sym-cell-set! sc2 temp))))

  ) ;; end module
