;; $Header: /home/larch/research/master/typedscm/Attic/ch3-simple-lambda.scm,v 1.3 1996/03/04 12:33:14 leavens Exp $

;; Simple lambda calculus in chapter 3

;;; Anonymous figure : page 84, 85, 86

(define-record lit (datum))
(define-record varref (var))
(define-record lambda (formal body))
(define-record app (rator rand))

(define parse
  ; TYPE: (-> (exp) parsed-exp)
  (lambda (datum)
    (cond
      ((number? datum) (make-lit datum))
      ((symbol? datum) (make-varref datum))
      ((pair? datum)
       (if (eq? (car datum) 'lambda)
           (make-lambda (caadr datum) (parse (caddr datum)))
           (make-app (parse (car datum)) (parse (cadr datum)))))
      (else (error "parse: Invalid concrete syntax" datum)))))

(define unparse
  ; TYPE: (-> (parsed-exp) exp)
  (lambda (exp)
    (variant-case exp
      (lit (datum) datum)
      (varref (var) var)
      (lambda (formal body) 
        (list 'lambda (list formal) (unparse body)))
      (app (rator rand) (list (unparse rator) (unparse rand)))
      (else (error "unparse: Invalid abstract syntax" exp)))))
