;;; Name:  Gary T. Leavens
;;; Section:  all

;;; Grammar:
;;;  <lambda-calculus-exp> ::= <varref>
;;;                          | (lambda (<var>) <lambda-calculus-exp>
;;;                          | (<lambda-calculus-exp> <lambda-calculus-exp>)
;;; <varref> ::= <var>
;;; <var> ::= <symbol>

(define varref? symbol?)  ; TYPE: (-> (datum) boolean)

(define lambda?  ; TYPE: (-> (datum) boolean)
  (lambda (exp)
    (and (list? exp)
	 (= (length exp) 3)
	 (eq? (car exp) 'lambda))))

(define lambda->body   ; TYPE: (-> (lambda-calculus-exp) lambda-calculus-exp)
  ; REQUIRES: the argument is a lambda
  caddr)

(define app->rator   ; TYPE: (-> (lambda-calculus-exp) lambda-calculus-exp)
  ; REQUIRES: the argument is an application
  car)
(define app->rand    ; TYPE: (-> (lambda-calculus-exp) lambda-calculus-exp)
  ; REQUIRES: the argument is an application expression
  cadr)


(define count-varrefs  ; TYPE: (-> (lambda-calculus-exp) number)
  (lambda (exp)
    ; ENSURES: result is the number of <varref>s in exp
    (if (varref? exp)
	1
	(if (lambda? exp)
	    (count-varrefs (lambda->body exp))
	    (+ (count-varrefs (app->rator exp))
	       (count-varrefs (app->rand exp)))))))

(define all-varrefs   ; TYPE: (-> (lambda-calculus-exp) (list symbol))
    (lambda (exp)
      ; ENSURES: result is a list of all the <varref>s in exp
      ;          (this list may contain duplicate occurrences of symbols).
      (if (varref? exp)
	(list exp)
	(if (lambda? exp)
	    (all-varrefs (lambda->body exp))
	    (append (all-varrefs (app->rator exp))
		    (all-varrefs (app->rand exp)))))))
