;; cs342:parse-expr.scm  (this is a parser for expressions in the 
;;                        arithmetic expression grammar of homework 3 
;;                        and is used to make it easy to create test 
;;                        cases for one of the problems (#12 Spring 96)

(define-record literal (num))
(define-record op-call (left-arg op right-arg))
(define-record unary-minus (arg))

(define cs342:exp->unary-op car)
(define cs342:exp->unary-arg cadr)

(define cs342:unary-op?
  ;; TYPE (-> (<expression>) boolean)
  (lambda (exp)
    (and (list? exp)
         (= (length exp) 2)
         (eq? (cs342:exp->unary-op exp) '-))
  ))

(define cs342:exp->binary-op cadr)
(define cs342:exp->binary-arg1 car)
(define cs342:exp->binary-arg2 caddr)


(define cs342:binary-op?
  ;; TYPE (-> (<expression>) boolean)
  (lambda (exp)
    (and (list? exp)
         (= (length exp) 3)
         (let ( (dat (cs342:exp->binary-op exp)) )
           (or (eq? dat '+)
               (eq? dat '-)
               (eq? dat '*)
               (eq? dat '/)))
         )))

(define cs342:parse-expr
  (lambda (exp)
    (cond 
      ( (number? exp) (make-literal exp) )
      ( (cs342:binary-op? exp) 
          (make-op-call (cs342:parse-expr (cs342:exp->binary-arg1 exp))
                        (cs342:exp->binary-op exp)
                        (cs342:parse-expr (cs342:exp->binary-arg2 exp))) )
      ( (cs342:unary-op? exp)
          (make-unary-minus (cs342:parse-expr (cs342:exp->unary-arg exp))) )
      ( else (error "Invalid expression: " exp) )
      )))

