;; $Header: /home/larch/research/master/typedscm/Attic/parsed-lambda-calculus-examples.scm,v 1.2 1995/10/20 23:28:14 leavens Exp $

;;; Name:  Gary T. Leavens
;;; Sections:  all

(load-from-lib "ch3-simple-lambda.scm")

(define count-varrefs  ; TYPE: (-> (lambda-calculus-exp) number)
  (lambda (exp)
    ; ENSURES: result is the number of <varref>s in exp
    ; EXAMPLE: (count-varrefs (parse 'x)) ==> 1
    ; EXAMPLE: (count-varrefs (parse '(x x))) ==> 2
    ; EXAMPLE: (count-varrefs (parse '(lambda (y) (car y)))) ==> 2
    (variant-case exp
     (lit () 0)
     (varref () 1)
     (lambda (body) (count-varrefs body))
     (app (rator rand)
	  (+ (count-varrefs rator)
	     (count-varrefs rand)))
     (else (error "invalid lambda calculus syntax!")))))

(define all-varrefs   ; TYPE: (-> (lambda-calculus-exp) (list symbol))
    (lambda (exp)
      ; ENSURES: result is a list of all the <varref>s in exp
      ;          (this list may contain duplicate occurrences of symbols.
      ; EXAMPLE: (all-varrefs (parse '(lambda (y) (car y)))) ==> (car y)
      (variant-case exp
       (lit () '())
       (varref (var) (list var))
       (lambda (body) (all-varrefs body))
       (app (rator rand) (append (all-varrefs rator)
				 (all-varrefs rand)))
       (else (error "invalid lambda calculus syntax!")))))

