;;; $Id: tc-compute-global-var-types.scm,v 1.6 2006/01/18 23:17:27 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

;;; Types for built-in Scheme procedures
;;; AUTHORS: Curtis Clifton and Gary T. Leavens,
;;;          from an earlier verison by Steven L. Jenkins.

(module tc-compute-global-var-types (lib "typedscm.ss" "typedscm")

  (provide *tc:pre-global-var-types*)
  
  (require (lib "tc-env.scm" "typedscm")
	   (lib "tc-global-var-output-types.scm" "typedscm")
	   (lib "tc-type-translate.scm" "typedscm")
           (lib "tc-compute-cxr-types.scm" "typedscm"))

  (deftype *tc:pre-global-var-types* (tc:env-of symbol tc:type-expr))
  (define *tc:pre-global-var-types*
    (tc:env-map
     (lambda (sym output-typ)
       (tc:type-parse output-typ))
     (tc:env-join *tc:pre-global-var-output-type-env*
		  *tc:cxr-output-type-env*)))
  )
