;; Thanks to Michael Ciccotti for the following example.

;; If you uncomment the typedef below, then then program type checks,
;; but it doesn't type check without the deftype, even though it
;; infers the exact same type as in the deftype!
;(deftype linem (forall (T) (-> (number T T) (list-of T))))
(define (linem num elem1 elem2)
  (if (= num 0)
      '()
      (cons elem1 (linem (- num 1) elem2 elem1))))

(deftype make-matrix (-> (number) (list-of (list-of number))))
(define (make-matrix num)
  (linem num ;; this call gives the error
         (linem num 0 1) (linem num 1 0)))

;;; $Id: deftype-makes-error-go-away.scm,v 1.2 2006/02/09 18:03:26 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.
